type Num    struct { val int }
type Format interface { format() string }
type Pretty interface { format() string; pretty() string }

func (this Num) format() string { return intToString(this.val) }
func (this Num) pretty() string { return this.format() }

func formatSome(x Format) string { return x.format() }

type Any interface {}

func asFormat(x Any) Format {
  return x.(Format)
}

func main() {
  var s1 string = formatSome(Num{1})
  var pr Pretty = Num{2}
  var s2 string = formatSome(pr)
}
