-- Field access for struct Num
val x = x

-- Method calls on interfaces
format$_{\sub{Format}}$ (x, f) = f x$\hspace{10.1mm}$-- call format on receiver of type Format
format$_{\sub{Pretty}}$ (x, (f,p)) = f x$\hspace{3mm}$-- call format on receiver of type Pretty
pretty$_{\sub{Pretty}}$ (x, (f,p)) = p x$\hspace{3mm}$-- call pretty on receiver of type Pretty

-- Method definitions (lines 5 and 6 in the FGG code)
format$_{\sub{Num}}$ this = intToString (val this)
pretty$_{\sub{Num}}$ this = format$_{\sub{Num}}$ this

-- Coercions
toFormat$_{\sub{Num}}$ x  = (x,format$_{\sub{Num}}$)               -- Num <: Format
toPretty$_{\sub{Num}}$ x  = (x,(format$_{\sub{Num}}$,pretty$_{\sub{Num}}$))   -- Num <: Pretty
toFormat$_{\sub{Pretty}}$ (x,(f,p))  = (x,f)            -- Pretty <: Format

-- Function definitions (lines 8 and 10 in the FGG code)
formatSome x = format$_{\sub{Format}}$ x

main = let s1 = formatSome (toFormat$_{\sub{Num}}$ 1)
           pr = toPretty$_{\sub{Num}}$ 2
           s2 = formatSome (toFormat$_{\sub{Pretty}}$ pr)
       in (s1, s2)
