-- Field access
val x = x
left (x, _) = x
right (_, x) = x

-- Method definitions
eq$_{\sub{Eq}}$ (x, eq) y = eq x y
eq$_{\sub{Num}}$ this that = val this == val that
eq$_{\sub{Pair}}$ (lift$_{\sub{T}}$, lift$_{\sub{U}}$) this that = eq$_{\sub{Eq}}$ (lift$_{\sub{T}}$ (left this)) (left that) &&
                                eq$_{\sub{Eq}}$ (lift$_{\sub{U}}$ (right this)) (right that)

-- Interface value construction
toEq$_{\sub{Num}}$ x = (x, eq$_{\sub{Num}}$)
toEq$_{\sub{Pair}}$ (lift$_{\sub{T}}$, lift$_{\sub{U}}$) x = (x, eq$_{\sub{Pair}}$ (lift$_{\sub{T}}$, lift$_{\sub{U}}$))

-- Function definitions
contains lift$_{\sub{T}}$ x p = eq$_{\sub{Eq}}$ (lift$_{\sub{T}}$ x) (left p) || eq$_{\sub{Eq}}$ (lift$_{\sub{T}}$ (right p)) x

main = let i = 1
           p = (i, 2)
           b1 = contains toEq$_{\sub{Num}}$ i p
           pp = (p, p)
           b2 = contains (toEq$_{\sub{Pair}}$ (toEq$_{\sub{Num}}$, toEq$_{\sub{Num}}$)) p pp
       in (b1, b2)
