-- Field access
valNum x = x
valBool x = x
left (x, _) = x
right (_, x) = x

-- Method definitions
eq$_{\sub{Num}}$ () this () that = val this == val that
eq$_{\sub{Pair}}$ (toEq$_{\sub{T}}$, toEq$_{\sub{U}}$) this () that =
   (case toEq$_{\sub{T}}$ (left this) of
      (x, eq) -> eq (x, (), left that))
    &&
    (case toEq$_{\sub{U}}$ (right this) of
      (x, eq) -> eq (x, (), right that)

contains$_{\sub{Pair}}$ toEq$_{\sub{T}}$ this toEq$_{\sub{S}}$ p =
   (case toEq$_{\sub{T}}$ (left this) of
      (x, eq) -> eq (x, (), right this))
   &&
   (case toEq$_{\sub{S}}$ (left p) of
      (x, eq) -> eq (x, (), right p))

-- toEq_T not used, only there for typing purposes
-- due to the bound in the Contains interface
eqSome$_{\sub{Num}}$ () this toEq$_{\sub{T}}$ (that, x) =
   case that of
     (y, contains) -> contains (y,(), (that,x))



-- Coercions
 -- Num <: Eq
toEq$_{\sub{Num}}$ x = (x, eq$_{\sub{Num}}$ ())
 -- Bool <: Eq
toEq$_{\sub{Bool}}$ x = (x, eq$_{\sub{Bool}}$ ())
-- Pair <: Eq
toEq$_{\sub{Pair}}$ (toEq$_{\sub{T}}$, toEq$_{\sub{U}}$) x =
   (x, eq$_{\sub{Pair}}$ (toEq$_{\sub{T}}$, toEq$_{\sub{U}}$))
-- Pair <: Contains
toContains$_{\sub{Pair}}$ toEq$_{\sub{T}}$ x =
   (x, contains$_{\sub{Pair}}$ toEq$_{\sub{T}}$)


main = let i = 1
           b = true
           p = (i, 2)
           q = (b, false)
           b2 = contains$_{\sub{Pair}}$ toEq$_{\sub{Num}}$ p toEq$_{\sub{Num}}$ q
           b3 = eqSome$_{\sub{Num}}$ ((), 1, toEq$_{\sub{Num}}$, toContains$_{\sub{Pair}}$ toEq$_{\sub{Num}}$ p)
       in b2 && b3
