type Num  struct { val int }
type Bool struct { val bool }
type Pair$\tyarg{[T Any, U Any]}$ struct { left  T; right U }
type Eq$\tyarg{[T Any]}$  interface { eq(that T) bool }

func (this Num) eq(that Num) bool { return this.val == that.val }
func (this Bool) eq(that Bool) bool { return this.val == that.val }
func (this Pair$\tyarg{[T Eq[T], U Eq[U]]}$) eq(that Pair$\tyarg{[T, U]}$) bool {
  return this.left.eq(that.left) && this.right.eq(that.right)
}

// Method with inner bound
func (this p Pair$\tyarg{[T Eq[T], T Eq[T]]}$) contains$\tyarg{[S Eq[S]]}$(p Pair$\tyarg{[S, S]}$) bool {
	return this.left.eq(this.right) || p.left.eq(p.right)
}

// Interface with inner bound
type Contains[T Eq[T]] interface { contains$\tyarg{[S Eq[S]]}$(p Pair$\tyarg{[S, S]}$) bool }

func (this Num) eqSome[T Eq[T]](that Contains[T], x T) bool {
	return that.contains[Bool](Pair$\tyarg{[Bool, Bool]}${Bool{true}, Bool{false}})
}


func main() {
  var i  = Num{1}
  var b  = Bool{true}
  var p  = Pair$\tyarg{[Num, Num]}${i, Num{2}}
  var q  = Pair$\tyarg{[Bool, Bool]}${b, Bool{false}}
  var b2 = p.contains$\tyarg{[Pair[Bool, Bool]]}$(i, b, q)
  var b3 = Num{1}.eqSome[Num](p)
  var _  = b2 && b3
}
