-- Field access for struct Pair
left (x, _) = x
right (_, x) = x

-- Method definition (line 4 in the FGG code)
format$_{\sub{Pair}}$ (toFormat$_{\sub{T}}$, toFormat$_{\sub{U}}$) this =
  "(" ++ format$_{\sub{Format}}$ (toFormat$_{\sub{T}}$ (left this)) ++
  "," ++ format$_{\sub{Format}}$ (toFormat$_{\sub{U}}$ (right this)) ++ ")"

-- Coercion Pair[T, U] <: Format (given T <: Format and U <: Format)
toFormat$_{\sub{Pair}}$ (toFormat$_{\sub{T}}$,toFormat$_{\sub{U}}$) p = (p,format$_{\sub{Pair}}$ (toFormat$_{\sub{T}}$,toFormat$_{\sub{U}}$))

-- Main function
main2 = let p = (1, 2)
            s1 = format$_{\sub{Pair}}$ (toFormat$_{\sub{Num}}$, toFormat$_{\sub{Num}}$) p
            s2 = formatSome (toFormat$_{\sub{Pair}}$ (toFormat$_{\sub{Num}}$, toFormat$_{\sub{Num}}$) p)
        in (s1, s2)
