-- Field access for struct FPair
left$_{\sub{FPair}}$ (x, _) = x
right$_{\sub{FPair}}$ (_, x) = x

-- Method call on interface
create$_{\sub{Factory}}$ (x, f) = f x -- call create on receiver of type Factory

-- Method definition (line 5 in the source program)
create$_{\sub{MyFactory}}$ this = (1, 2)

-- Coercion
toFactory$_{\sub{MyFactory}}$ x = (x, create$_{\sub{MyFactory}}$) -- MyFactory <: Factory[Num]

-- Function definition (line 9 in the source program)
doWork toFormat$_{\sub{T}}$ factory =
  let p = create$_{\sub{Factory}}$ factory
      t = left$_{\sub{FPair}}$ p
  in format$_{\sub{Format}}$ (toFormat$_{\sub{T}}$ t)

main4 = doWork toFormat$_{\sub{Num}}$ (toFactory$_{\sub{MyFactory}}$ ())
